/*
 * QEstEidCommon
 *
 * Copyright (C) 2011-2012 Jargo Kõster <jargo@innovaatik.ee>
 * Copyright (C) 2011-2012 Raul Metsma <raul@innovaatik.ee>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#pragma once

#include <QLibrary>

#ifdef Q_OS_WIN
#pragma warning(push)
#pragma warning(disable:4201)
#include <winsock2.h>
#include <winscard.h>
#pragma warning(pop)
#else
#include <PCSC/wintypes.h>
#include <PCSC/winscard.h>
#include <arpa/inet.h>
#include <stdint.h>
#endif

#ifndef CM_IOCTL_GET_FEATURE_REQUEST
#ifdef _MSC_VER
typedef unsigned __int8 uint8_t;
typedef unsigned __int16 uint16_t;
typedef unsigned __int32 uint32_t;
#endif
#include "internal-pcsc22.h"
#endif

#ifdef Q_OS_WIN
#  define SCAPI __stdcall
#  define SUFFIX "A"
#  define CSTRTYPE const CHAR *
#  undef SCARD_READERSTATE
#  define SCARD_READERSTATE SCARD_READERSTATEA
#else
#  define SCAPI
#  define SUFFIX ""
#  ifdef LPCTSTR
#    define CSTRTYPE LPCSTR
#  else
#    define CSTRTYPE LPSTR
#  endif
#endif

typedef LONG (SCAPI *sym_SCardEstablishContext)( DWORD scope,
	LPCVOID res1, LPCVOID res2, SCARDCONTEXT *context );
typedef LONG (SCAPI *sym_SCardReleaseContext)( SCARDCONTEXT hContext );
typedef LONG (SCAPI *sym_SCardListReaders)( SCARDCONTEXT hContext,
	CSTRTYPE mszGroups, LPSTR mszReaders, LPDWORD pcchReaders );
typedef LONG (SCAPI *sym_SCardGetStatusChange)( SCARDCONTEXT hContext,
	DWORD dwTimeout, SCARD_READERSTATE *rgReaderStates, DWORD cReaders );
typedef LONG (SCAPI *sym_SCardConnect)( SCARDCONTEXT hContext, CSTRTYPE szReader,
	DWORD dwShareMode, DWORD dwPreferredProtocols, LPSCARDHANDLE hCard, LPDWORD pdwActiveProtocol );
typedef LONG (SCAPI *sym_SCardReconnect)( SCARDHANDLE hCard, DWORD dwShareMode,
	DWORD dwPreferredProtocols, DWORD dwInitialization, LPDWORD pdwActiveProtocol );
typedef LONG (SCAPI *sym_SCardDisconnect)( SCARDHANDLE hCard, DWORD dwDisposition );
typedef LONG (SCAPI *sym_SCardControl)( SCARDHANDLE hCard, DWORD dwControlCode, LPCVOID lpInBuffer,
	DWORD nInBufferSize, LPVOID lpOutBuffer, DWORD nOutBufferSize, LPDWORD lpBytesReturned );

class QPCSCPrivate
{
public:
	QPCSCPrivate();

	QLibrary lib;

	SCARDCONTEXT context;

	sym_SCardEstablishContext SCardEstablishContext;
	sym_SCardReleaseContext SCardReleaseContext;
	sym_SCardListReaders SCardListReaders;
	sym_SCardGetStatusChange SCardGetStatusChange;
	sym_SCardConnect SCardConnect;
	sym_SCardReconnect SCardReconnect;
	sym_SCardDisconnect SCardDisconnect;
	sym_SCardControl SCardControl;
};

class QPCSCReaderPrivate
{
public:
	QPCSCReaderPrivate( QPCSCPrivate *d );

	bool updateState();

	QPCSCPrivate *d;
	SCARDHANDLE card;
	DWORD proto;
	SCARD_READERSTATE state;
	QByteArray reader;

	DWORD verify_ioctl, verify_ioctl_start, verify_ioctl_finish;
	DWORD modify_ioctl, modify_ioctl_start, modify_ioctl_finish;
	bool display;
};
