/*
 * QEstEidUtil
 *
 * Copyright (C) 2011-2012 Jargo Kõster <jargo@innovaatik.ee>
 * Copyright (C) 2011-2012 Raul Metsma <raul@innovaatik.ee>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#pragma once

#include <QXmlStreamReader>

#include <QHash>

class XmlReader: public QXmlStreamReader
{
public:
	XmlReader( const QByteArray &data );

	QStringList readEmailStatus( QString &fault );
	QHash<QString,QString> readMobileStatus( int &faultcode );

	static QString emailErr( quint8 code );
	static QString mobileErr( quint8 code );
	static QString mobileStatus( const QString &status );

private:
	QStringList readEmailAddresses();
	QString readForwards();
};
